module Opdracht1 where
import List

compilers :: Table
compilers =
  [ ["        ", "                    "]
  , ["      ", "                    "]
  , ["   ", "                  "]
  , ["   ", "                  "]
  , ["    ", "                  "]
  , ["        ", "                  "]
  , ["         ", "                         "]
  , ["         ", "                                 "]
  , ["   ", "                                 "]
  ]

locaties :: Table
locaties =
  [ ["                    ", "    ", "    "]
  , ["                    ", "         ", "       "]
  , ["                  ", "        ", "    "]
  , ["                  ", "        ", "         "]
  , ["                  ", "                ", "         "]
  , ["                         ", "                ", "         "]
  , ["                                 ", "      ", "        "]
  ]

soort :: Table
soort =
  [ ["                    ", "     "]
  , ["                    ", "            "]
  , ["                  ", "            "]
  , ["                  ", "       "]
  , ["                  ", "       "]
  , ["                         ", "            "]
  , ["                                 ", "            "]
  ]

query :: Table
query =
    project ["        "]
      (select "     " (eqString "            ")
        (join compilers (join locaties soort)))

type Table = [[String]]

--                       
--                                     
bepaalLangsteWoord :: [String] -> Int
bepaalLangsteWoord xs = maximum (map length xs)

--                                                                                                                    
breedteKolom               :: Table -> [Int]
breedteKolom tabel         = map bepaalLangsteWoord (transpose tabel)

--                 
schrijfRegel               :: [Int] -> [String] -> String
schrijfRegel _ []          = "   "
schrijfRegel ns (x:xs)     = " " ++ x ++ replicate (head ns - length x) ' ' ++ schrijfRegel (tail ns) xs

--                     
schrijfRegels   :: [Int]->Table -> String
schrijfRegels widths tabel       = concatMap (schrijfRegel widths) tabel

--                      
scheidingsRegel :: [Int] -> String
scheidingsRegel (x:xs)     = " " ++ replicate (x) '-' ++ scheidingsRegel xs
scheidingsRegel []         = "   "

--               
writeTable :: Table -> String
writeTable [] = ""
writeTable tabel = str ++ schrijfRegel widths (head tabel) ++ str ++ schrijfRegels widths (tail tabel)++ str
                where  str = scheidingsRegel(breedteKolom tabel)
                       widths = breedteKolom tabel

--                                    
--                    


--                       
project :: [String] -> Table -> Table
project x tabel  = transpose (controleTotaal x tabel)

controleTotaal :: [String] -> Table -> Table
controleTotaal [] _           = []
controleTotaal (x:xs) tabel   | not (null p)                           = p: controleTotaal xs tabel
                              | otherwise                              = controleTotaal xs tabel
                       where p = (controlePerWoord x (transpose tabel ))

controlePerWoord :: String -> Table -> [String]
controlePerWoord _ []                       = []
controlePerWoord x (y:ys)                   | eqString x (head y) = y
                                            | otherwise           = controlePerWoord x ys


--                                               "    " "    "  "    "                         
--                                                                                                 "    " "    "  "    "               

--                             "    " "    "  "    "              
--               


--                      
select :: String -> (String -> Bool) -> Table -> Table

select veld conditie tabel =  head tabel:selecteerRijen (filter conditie (drop 1 k)) tabel
       where k = controlePerWoord veld  (transpose tabel )

selecteerRijen :: [String] -> Table -> Table
selecteerRijen []           _                                             = []
selecteerRijen _            []                                            = []
selecteerRijen lijst@(y:ys) tabel@(x:xs) | elemBy eqString y x            = x :  selecteerRijen ys xs
                                         | otherwise                       = selecteerRijen lijst xs
--                                                                            

join :: Table -> Table -> Table
join table1 table2 = concatMap (makeCombinations kleinste gemKolom) grootste
                   where (kleinste, grootste) = geefVerdeling table1 table2
                         gemKolom = vindGem (head table1) (head table2)



makeCombinations :: Table -> String -> [String] -> Table
makeCombinations zoekTabel gemKolom refRij = undefined
--                                                                                          -  

--                                                  
geefVerdeling :: Table -> Table -> (Table,Table)
geefVerdeling tabel1 tabel2 | length(head(transpose(tabel1)))>=(length(head(transpose(tabel2)))) = (tabel2, tabel1)
                            | otherwise                                                          = (tabel1, tabel2)


--                                                                 
vindGem :: [String] -> [String] -> String
vindGem [] _          = []
vindGem (x:xs) l      | elemBy eqString x l = x
                      | otherwise    = vindGem xs l

--                  -        -          
gemKolom tabel1 tabel2 = project [(vindGem tabel1 tabel2)] (snd (geefVerdeling tabel1 tabel2))










--                       
{--joinen van tabellen
join :: Table -> Table -> Table
join _ [] = [[]]
join [] _ = [[]]
join table1 table2 = transpose ( (transpose (delKolom gemKolom (geefKortste table1 table2))) ++ (transpose (check table1 table2)) )
                   where gemKolom = (vindGem (head table1) (head table2))


--geefVerdeling resp. geefKortste leveren de langste resp. kortste rij op
geefGrootste :: Table -> Table -> Table
geefGrootste tabel1 tabel2 | length(head(transpose(tabel1)))>=(length(head(transpose(tabel2)))) = tabel1
                            | otherwise                                                         = tabel2

  {-
--check doet eerst het juist woord, dan de juiste kolom gevonden te hebben, bij elk woord de juiste rij zoeken
check :: Table -> Table -> Table
check tabel1 tabel2 = selecteerRijen (controlePerWoord (vindGem (head tabel1)(head tabel2)) (transpose (geefLangste tabel1 tabel2))) (geefLangste tabel1 tabel2)
--

--Deze doet de opgeleverde delKolom2 transposen
delKolom :: String->Table->Table
delKolom str t = transpose (delKolom2 str (transpose t))

--Deze kijkt of een bepaalde string in een tabel voorkomt, als ja, dan wordt de tabel verwijdert.
delKolom2 :: String->Table->Table
delKolom2 _ [] = []
delKolom2 x (y:ys) | not (eqString x (head y)) = y:delKolom2 x ys
                   | otherwise                 = delKolom2 x ys


   -}











       
       
       
       
       
       
       

















































