module Offopdracht1 where
import List

------------------------------------------------------------------------------------------------------------------------
--        
------------------------------------------------------------------------------------------------------------------------

compilers :: Table
compilers =
  [ ["        ", "                    "]
  , ["      ", "                    "]
  , ["   ", "                  "]
  , ["   ", "                  "]
  , ["    ", "                  "]
  , ["        ", "                  "]
  , ["         ", "                         "]
  , ["         ", "                                 "]
  , ["   ", "                                 "]
  ]

locaties :: Table
locaties =
  [ ["                    ", "    ", "    "]
  , ["                    ", "         ", "       "]
  , ["                  ", "        ", "    "]
  , ["                  ", "        ", "         "]
  , ["                  ", "                ", "         "]
  , ["                         ", "                ", "         "]
  , ["                                 ", "      ", "        "]
  ]

soort :: Table
soort =
  [ ["                    ", "     "]
  , ["                    ", "            "]
  , ["                  ", "            "]
  , ["                  ", "       "]
  , ["                  ", "       "]
  , ["                         ", "            "]
  , ["                                 ", "            "]
  ]

sort :: Table
sort =
  [ ["                   ", "     "]
  , ["                    ", "            "]
  , ["                  ", "            "]
  , ["                  ", "       "]
  , ["                  ", "       "]
  , ["                         ", "            "]
  , ["                                 ", "            "]
  , ["                                 ", "            "]
  ]

query :: Table
query =
    project ["        "]
      (select "     " (eqString "            ")
        (join compilers (join locaties soort)))


------------------------------------------------------------------------------------------------------------------------
--                  
------------------------------------------------------------------------------------------------------------------------
type Table = [[String]]


------------------------------------------------------------------------------------------------------------------------
--                       
------------------------------------------------------------------------------------------------------------------------

--                                     
bepaalLangsteWoord :: [String] -> Int
bepaalLangsteWoord xs = maximum (map length xs)

--                                                                                               
breedteKolom               :: Table -> [Int]
breedteKolom tabel         = map bepaalLangsteWoord (transpose tabel)

--                 
schrijfRegel               :: [Int] -> [String] -> String
schrijfRegel _ []          = "   "
schrijfRegel ns (x:xs)     = " " ++ x ++ replicate (head ns - length x) ' ' ++ schrijfRegel (tail ns) xs

--                     
schrijfRegels   :: [Int]->Table -> String
schrijfRegels widths tabel       = concatMap (schrijfRegel widths) tabel

--                      
scheidingsRegel :: [Int] -> String
scheidingsRegel (x:xs)     = " " ++ replicate (x) '-' ++ scheidingsRegel xs
scheidingsRegel []         = "   "

--               
writeTable :: Table -> String
writeTable [] = ""
writeTable tabel = str ++ schrijfRegel widths (head tabel) ++ str ++ schrijfRegels widths (tail tabel)++ str
                where  str = scheidingsRegel(breedteKolom tabel)
                       widths = breedteKolom tabel


------------------------------------------------------------------------------------------------------------------------
--                       
------------------------------------------------------------------------------------------------------------------------

project :: [String] -> Table -> Table
project x tabel  = transpose (controleTotaal x tabel)

--                                      
controleTotaal :: [String] -> Table -> Table
controleTotaal [] _           = []
controleTotaal (x:xs) tabel   | not (null p)                           = p: controleTotaal xs tabel
                              | otherwise                              = controleTotaal xs tabel
                       where p = (controlePerWoord x (transpose tabel ))

--                                                 
controlePerWoord :: String -> Table -> [String]
controlePerWoord _ []                       = []
controlePerWoord x (y:ys)                   | eqString x (head y) = y
                                            | otherwise           = controlePerWoord x ys

------------------------------------------------------------------------------------------------------------------------
--                      
------------------------------------------------------------------------------------------------------------------------

--                                                        
select :: String -> (String -> Bool) -> Table -> Table
select veld conditie tabel =  head tabel:selecteerRijen (filter conditie (drop 1 k)) tabel
       where k = controlePerWoord veld  (transpose tabel )

selecteerRijen :: [String] -> Table -> Table
selecteerRijen []           _                                             = []
selecteerRijen _            []                                            = []
selecteerRijen lijst@(y:ys) tabel@(x:xs) | elemBy eqString y x            = x :  selecteerRijen ys xs
                                         | otherwise                       = selecteerRijen lijst xs
--                                                                                                

------------------------------------------------------------------------------------------------------------------------
--                       
------------------------------------------------------------------------------------------------------------------------

--                                                               
join :: Table -> Table -> Table
join tabel1 tabel2      | null (leverTabel tabel1 tabel2)    = []
                        | otherwise                          = transpose((transpose((snd (geefVerdeling tabel1 tabel2))))++(transpose(leverTabel tabel1 tabel2)))

--                                                                                                                                                    
leverTabel :: Table -> Table -> Table
leverTabel tabel1 tabel2 = makeCombinaties (geefGemKolom tabel1 tabel2) (transpose(leverGoedOp (vindGem (head tabel1)(head tabel2))  (transpose (fst (geefVerdeling tabel1 tabel2) ) ) ))


--                                                                                           
--                                                                                              
leverGoedOp :: String -> Table -> Table
leverGoedOp _   [[]]                                    = []
leverGoedOp ""  _                                       = []
leverGoedOp k   t | eqString k (head (head t))          = t
                  | eqString k (head (head(tail t)))    = ((head(tail t)) : (head t) : (tail(tail t)))
                  | otherwise                           = (leverGoedOp k (tail(tail t))) ++ [(head t)] ++ [(head(tail t))]

--                                                                                                                                         
makeCombinaties:: Table -> Table -> Table
makeCombinaties []    _                 = []
makeCombinaties _     []                = []
makeCombinaties kolom korteTabel        |eqString (head (head kolom)) (head(head korteTabel))   = (tail (head korteTabel)) : (makeCombinaties (tail kolom) (korteTabel))
                                        |otherwise                                              = [] ++ (makeCombinaties (kolom) (tail korteTabel))

--                                                                                                                                             
geefGemKolom :: Table -> Table -> Table
geefGemKolom tabel1 tabel2 = project [(vindGem (head tabel1) (head tabel2))] (snd (geefVerdeling tabel1 tabel2))

--                                                                 
vindGem :: [String] -> [String] -> String
vindGem [] _          = []
vindGem (x:xs) l      | elemBy eqString x l = x
                      | otherwise    = vindGem xs l

--                                                  
geefVerdeling :: Table -> Table -> (Table,Table)
geefVerdeling tabel1 tabel2 | length(head(transpose(tabel1)))>=(length(head(transpose(tabel2)))) = (tabel2, tabel1)
                            | otherwise                                                          = (tabel1, tabel2)


