module OpdrachtEIND where
import List
--                -         

------------------------------------------------------------------------------------------------------------------------
--        
------------------------------------------------------------------------------------------------------------------------

compilers :: Table
compilers =
  [ ["        ", "                    "]
  , ["      ", "                    "]
  , ["   ", "                  "]
  , ["   ", "                  "]
  , ["    ", "                  "]
  , ["        ", "                  "]
  , ["         ", "                         "]
  , ["         ", "                                 "]
  , ["   ", "                                 "]
  ]


locaties :: Table
locaties =
  [ ["                    ", "    ", "    "]
  , ["                    ", "         ", "       "]
  , ["                  ", "        ", "    "]
  , ["                  ", "        ", "         "]
  , ["                  ", "                ", "         "]
  , ["                         ", "                ", "         "]
  , ["                                 ", "      ", "        "]
  ]

soort :: Table
soort =
  [ ["                    ", "     "]
  , ["                    ", "            "]
  , ["                  ", "            "]
  , ["                  ", "       "]
  , ["                  ", "       "]
  , ["                         ", "            "]
  , ["                                 ", "            "]
  ]

query :: Table
query =
    project ["        "]
      (select "     " (eqString "            ")
        (join compilers (join locaties soort)))


------------------------------------------------------------------------------------------------------------------------
--                  
------------------------------------------------------------------------------------------------------------------------
type Table = [[String]]


------------------------------------------------------------------------------------------------------------------------
--       ----                        
------------------------------------------------------------------------------------------------------------------------
--               
writeTable :: Table -> String
writeTable []       = ""
writeTable tabel    = str ++ schrijfRegel widths (head tabel) ++ str ++ schrijfRegels widths (tail tabel)++ str
                where str = scheidingsRegel(breedteKolom tabel)
                      widths = breedteKolom tabel

--                      
scheidingsRegel :: [Int] -> String
scheidingsRegel (x:xs)     = " " ++ replicate (x) '-' ++ scheidingsRegel xs
scheidingsRegel []         = "   "

--                     
schrijfRegels   :: [Int]->Table -> String
schrijfRegels widths tabel       = concatMap (schrijfRegel widths) tabel

--                 
schrijfRegel               :: [Int] -> [String] -> String
schrijfRegel _ []          = "   "
schrijfRegel ns (x:xs)     = " " ++ x ++ replicate (head ns - length x) ' ' ++ schrijfRegel (tail ns) xs

--                                                                            
breedteKolom               :: Table -> [Int]
breedteKolom tabel         = map bepaalLangsteWoord (transpose tabel)

--                                     
bepaalLangsteWoord :: [String] -> Int
bepaalLangsteWoord xs = maximum (map length xs)


------------------------------------------------------------------------------------------------------------------------
--       ----                        
------------------------------------------------------------------------------------------------------------------------

project :: [String] -> Table -> Table
project x tabel  = transpose (controleTotaal x tabel)

--                                      
controleTotaal :: [String] -> Table -> Table
controleTotaal [] _           = []
controleTotaal (x:xs) tabel   | not (null p)                           = p: controleTotaal xs tabel
                              | otherwise                              = controleTotaal xs tabel
                       where p = (controlePerWoord x (transpose tabel ))

--                                                 
controlePerWoord :: String -> Table -> [String]
controlePerWoord _ []           = []
controlePerWoord x (y:ys)       | eqString x (head y) = y
                                | otherwise           = controlePerWoord x ys

------------------------------------------------------------------------------------------------------------------------
--       ----                       
------------------------------------------------------------------------------------------------------------------------

--                                                        
select :: String -> (String -> Bool) -> Table -> Table
select veld conditie tabel =  head tabel:selecteerRijen (filter conditie (drop 1 k)) tabel
       where k = controlePerWoord veld  (transpose tabel )

selecteerRijen :: [String] -> Table -> Table
selecteerRijen []           _                                             = []
selecteerRijen _            []                                            = []
selecteerRijen lijst@(y:ys) (x:xs) | elemBy eqString y x            = x :  selecteerRijen ys xs
                                         | otherwise                       = selecteerRijen lijst xs

------------------------------------------------------------------------------------------------------------------------
--       ----                        
------------------------------------------------------------------------------------------------------------------------


join :: Table -> Table -> Table
join tabel1 tabel2 = transpose (nubBy (eqList eqString) (transpose voerUit))
                     where voerUit = [rij1++rij2 | rij1<-tabel1, rij2<-tabel2, vergelijk rij1 rij2]
                               where vergelijk rij1 rij2 = eqString element1 element2
                                                   where element1 = rij1!!(vindKolom p (head tabel1))
                                                         element2 = rij2!!(vindKolom p (head tabel2))
                                                         p = head(legeRijenWeg(geefPlek( ((head tabel1) ++ (head tabel2)))))

--                                                
vindKolom :: String -> [String] -> Int
vindKolom _ []         = 0
vindKolom kolom (x:xs) | eqString kolom x        = 0
                       | otherwise               = 1 + vindKolom kolom xs

--                                                                                                                                    
geefPlek :: [String] -> [String]
geefPlek []     = []
geefPlek (x:xs) = (veldPlek x xs) : (geefPlek xs)

--                                     
legeRijenWeg :: [String] -> [String]
legeRijenWeg []     = []
legeRijenWeg (x:xs) = filter  (not.eqString "") (x:xs)
                              
--                                                                                            
veldPlek :: String -> [String] -> String
veldPlek _        []     = []
veldPlek veldnaam (x:xs) | eqString veldnaam x = x ++ (veldPlek veldnaam xs)
                         | otherwise           = veldPlek veldnaam xs
                         
------------------------------------------------------------------------------------------------------------------------
--      ----                              
------------------------------------------------------------------------------------------------------------------------
sorteer tabel = undefined
------------------------------------------------------------------------------------------------------------------------
--      ----                 
------------------------------------------------------------------------------------------------------------------------
voegToe rij tabel | (length (head tabel)) == (length (rij))  = tabel ++ [rij]      




--                         
--                     


