module OpdrachtEIND where
import List
--                -        

------------------------------------------------------------------------------------------------------------------------
--        
------------------------------------------------------------------------------------------------------------------------

compilers :: Table
compilers =
  [ ["        ", "                    "]
  , ["      ", "                    "]
  , ["   ", "                  "]
  , ["   ", "                  "]
  , ["    ", "                  "]
  , ["        ", "   "]
  , ["         ", "                         "]
  , ["         ", "                                 "]
  , ["   ", "                                 "]
  ]

locaties :: Table
locaties =
  [ ["                    ", "    ", "    "]
  , ["                    ", "         ", "       "]
  , ["                  ", "        ", "    "]
  , ["                  ", "        ", "         "]
  , ["                  ", "                ", "         "]
  , ["                         ", "                ", "         "]
  , ["                                 ", "      ", "        "]
  ]

soort :: Table
soort =
  [ ["                    ", "     "]
  , ["                    ", "            "]
  , ["                  ", "            "]
  , ["                  ", "       "]
  , ["                  ", "       "]
  , ["                         ", "            "]
  , ["                                 ", "            "]
  ]

query :: Table
query =
    project ["        "]
      (select "     " (eqString "            ")
        (join compilers (join locaties soort)))


------------------------------------------------------------------------------------------------------------------------
--                  
------------------------------------------------------------------------------------------------------------------------
type Table = [[String]]


------------------------------------------------------------------------------------------------------------------------
--       ----                        
------------------------------------------------------------------------------------------------------------------------
--               
writeTable :: Table -> String
writeTable []       = ""
writeTable tabel    = str ++ schrijfRegel widths (head tabel) ++ str ++ schrijfRegels widths (tail tabel)++ str
                where str = scheidingsRegel(breedteKolom tabel)
                      widths = breedteKolom tabel

--                      
{-
                         -        
                             " "                   -                       
                             "   "
  -}
scheidingsRegel :: [Int] -> String
scheidingsRegel widths = " " ++ concatMap (\k -> replicate k '-' ++ " ") widths ++ "  "

--                     
schrijfRegels   :: [Int]->Table -> String
schrijfRegels widths tabel       = concatMap (schrijfRegel widths) tabel

--                 
schrijfRegel    :: [Int] -> [String] -> String
schrijfRegel ns xs  = concatMap (\(s,i) -> " " ++ s ++ replicate (i - length s) ' ') (zip xs ns)  ++ "   "

{-
                                    -           -        
                             "   "
                             " "                            -                                           
-}

--                                                                            
breedteKolom               :: Table -> [Int]
breedteKolom tabel         = map bepaalLangsteWoord (transpose tabel)

--                                     
bepaalLangsteWoord :: [String] -> Int
bepaalLangsteWoord xs = maximum (map length xs)


------------------------------------------------------------------------------------------------------------------------
--       ----                        
------------------------------------------------------------------------------------------------------------------------
--                                            
project :: [String] -> Table -> Table
project x = transpose.controleTotaal x

--                                      
controleTotaal :: [String] -> Table -> Table
controleTotaal [] _           = []
controleTotaal (x:xs) tabel   | not (null p)                           = p: controleTotaal xs tabel
                              | otherwise                              = controleTotaal xs tabel
                       where p = controlePerWoord x (transpose tabel )

--                                                 
controlePerWoord :: String -> Table -> [String]
controlePerWoord _ []           = []
controlePerWoord x (y:ys)       | eqString x (head y) = y
                                | otherwise           = controlePerWoord x ys



------------------------------------------------------------------------------------------------------------------------
--       ----                       
------------------------------------------------------------------------------------------------------------------------

--                                                        
select :: String -> (String -> Bool) -> Table -> Table
select veld conditie tabel =  head tabel:selecteerRijen (nummerKolom veld tabel) (filter conditie (drop 1 k)) tabel
       where k = controlePerWoord veld  (transpose tabel )

selecteerRijen :: Int -> [String] -> Table -> Table
selecteerRijen _ []           _                             = []
selecteerRijen _ _            []                            = []
selecteerRijen n lijst@(y:ys) (x:xs) | eqString y (x !! n)  = x :  selecteerRijen ys xs
                                     | otherwise            = selecteerRijen lijst xs

nummerKolom :: String -> Table -> Int
nummerKolom s t = snd (vindTupel s (zip (head t) [0..]))
            where vindTupel st l = head (filter (\(x,_) -> not(eqString st x) ) l)


------------------------------------------------------------------------------------------------------------------------
--       ----                        
------------------------------------------------------------------------------------------------------------------------
{-

              -        -       
                                                                            
                                                        -             -                            
                                                                                     
                                                                                            
                                                                                            
                                                                             
                                                                         
                                                                                     
                                                                                "                             "
                                                                  
                                                                                                          
                                                                           -                 -                              

--                                             
                    -           -     
                               "                             "
                                                    
                                                                         

-}
{-
            
            

   

                       

-}

{-
--                                                                                                                                    
                     -          
                    
                                                 

--                                     
                         -          
                                     "" 

--                                                                 
                   -           -        
                           ""
                                                                            
                                                                     
-}

------------------------------------------------------------------------------------------------------------------------
--      ----                              
------------------------------------------------------------------------------------------------------------------------
sorteer :: String -> Table -> Table
sorteer kolom tabel =
    head tabel :
    map (\(_,i) -> (tabel !! i))
        (sortBy myOrdTuple ( zip (drop 1 (geefKolom kolom tabel)) [1..]))

myOrdTuple :: (String, a) -> (String, b) -> Ordering
myOrdTuple (a,_) (c,_) = ordString a c

geefKolom :: String -> Table -> [String]
geefKolom kolom tabel = geefKolom2 kolom (transpose tabel)

geefKolom2 :: String -> Table -> [String]
geefKolom2 _ [] = []
geefKolom2 kolom (x:xs) | eqString kolom (head x) = x  --          
                        | otherwise               = geefKolom2 kolom xs

eqOrd :: Ordering -> Ordering -> Bool
eqOrd GT GT = True
eqOrd LT LT = True
eqOrd EQ EQ = True
eqOrd _  _  = False

klString :: String -> String -> Bool
klString s t = (ordString s t) `eqOrd` LT



------------------------------------------------------------------------------------------------------------------------
--      ----                 
------------------------------------------------------------------------------------------------------------------------
voegRijToe :: [String] -> Table -> Table
voegRijToe rij tabel | (length (head tabel)) == (length (rij))  = tabel ++ [rij]
                     | otherwise                                = error "                                                                         "

 ------------------------------------------------------------------------------------------------------------------------
--      ----                   
------------------------------------------------------------------------------------------------------------------------
voegKolomToe :: [String] -> Table -> Table
voegKolomToe kolom tabel | (length (head (transpose tabel))) == length(kolom) = transpose((transpose tabel) ++ [kolom])
                         | otherwise                                            = error "                                                                     "


