--         
import List

data Prop
  = En [Prop]     --                
  | Of [Prop]     --                
  | Niet Prop
  | Prop :-> Prop --                  
  | Var String    --          
  | Bool Bool     --           

type Bedeling = [String]

--                                                
evalueer :: Prop -> Bedeling -> Bool
evalueer (En props)        lijst     = all (\prop -> evalueer prop lijst) props
--           -                                  
--                                                                                                                        
evalueer (Of props)        lijst     = any (\prop -> evalueer prop lijst) props
evalueer (Niet prop)       lijst     = not (evalueer prop lijst)
evalueer (prop1 :-> prop2) lijst
        | evalueer prop1 lijst
          &&
          not (evalueer prop2 lijst) = False
        | otherwise                  = True
evalueer (Var s)           lijst     = elemBy eqString s lijst
evalueer (Bool b)          _         = b

--               -   
--                         
--          
--          
--   

--                                                                                                                                   
vervulbaar :: Prop -> [Bedeling]
vervulbaar p = filter (evalueer p) (subs (geefVariabelen p))
--       -                                                                                                                                 

--                                                                                       
subs :: [a] -> [[a]]
subs [] = [[]]
subs (x:xs) = map (x:) subsxs ++ subsxs
        where subsxs = subs xs
--                                                          
geefVariabelen :: Prop -> [String]
geefVariabelen (En props)        = concatMap geefVariabelen props
geefVariabelen (Of props)        = concatMap geefVariabelen props
geefVariabelen (Niet prop)       = geefVariabelen (prop)
geefVariabelen (prop1 :-> prop2) = geefVariabelen (prop1)++geefVariabelen (prop2)
geefVariabelen (Var s)           = [s]
geefVariabelen (Bool _)          = []

tautologie :: Prop -> Bool
tautologie p = all (evalueer p) (subs (geefVariabelen p))

contradictie :: Prop -> Bool
contradictie p = all (not.evalueer p) (subs (geefVariabelen p))
--                                                                 

toon :: Prop -> String
toon (En props)       = concatMap toon props
toon (Of props)       = concatMap toon props
toon (Niet prop)      = "  "++ toon prop ++ " "
toon (prop1 :-> prop2)= " "++ toon prop1 ++ " " ++ "    "++ " "++ toon prop2 ++" "
toon (Var s)          = s
toon (Bool b)         = if b then "    "
                             else "     "

--                   -       -      
--                                        
--                                        
--                                        
--                   -                    
--                                        
--                                        


--                 -      
--                               
--                               
--                               
--                 -             
--                               
--                               

--                  -      
--           




