{-------------------------------------------------------------------}
{-----------------                     -----------------------------}
{-----------------                     -----------------------------}
{-----------------                     -----------------------------}
{-------------------------------------------------------------------}

{-------------------------------------------------------------------}
{------------------------           --------------------------------}
{-------------------------------------------------------------------}

module WriteTable where

import List

type Table = [[String]]
type Column = [String]
type Row = [String]

testje::Table
testje = [["        ","          ","         "],["       ","      ","    "],["    ","        ","    "],["    ","      ","  "]]
testje2::Table
testje2 = [["      ","          ","        "],["        ","      ","  "],["    ","        ","  "],["    ","      ","  "]]

writeTable::Table->IO()
writeTable x = putStr (makeTable ( alignTable x))

makeTable::Table->String
makeTable [] = ""
makeTable (xs:xss) = (concat xs ++ "  ") ++ makeTable xss

alignTable::Table->Table
alignTable x = withRows (withColumns x)

withColumns::Table->Table
withColumns x = transpose (addLastVerticalLine (withSpaces (transpose x)))

withSpaces::Table->Table
withSpaces [] = []
withSpaces (xs:xss) = addVerticalLines (addSpaces xs (maxColumnWidth xs)) : withSpaces xss

addSpaces::[String]->Int->[String]
addSpaces [] _ = []
addSpaces _ 0 = []
addSpaces (x:xs) n =  (x ++ (concat (replicate (n - lengte) " "))) : addSpaces xs n
                                       where lengte = length x

maxColumnWidth::Column->Int
maxColumnWidth [] = 0
maxColumnWidth (x:xs) | (length x) > (maxColumnWidth xs) = length x
                      | otherwise = maxColumnWidth xs

addVerticalLines::Column->Column
addVerticalLines [] = []
addVerticalLines (x:xs) = concat( [" "]++[x] ) : addVerticalLines xs

addLastVerticalLine::Table->Table
addLastVerticalLine [] = []
addLastVerticalLine x = init x ++ [addLastVerticalLine' (last x)]

addLastVerticalLine'::Column->Column
addLastVerticalLine' [] = []
addLastVerticalLine' (x:xs) = (x++" ") : addLastVerticalLine' xs

withRows::Table->Table
withRows [] = []
withRows (xs:xss) = (addLastPlus (makeRow xs)) : xs : (addLastPlus (makeRow xs)) : restTable xss xs

restTable::Table->Row->Table
restTable [] _ = []
restTable _ [] = []
restTable x y = x ++ [addLastPlus (makeRow y)]

makeRow::Row->Row
makeRow [] = []
makeRow (x:xs) = concat ( " " : (replicate (length x - 1) " ") ) : makeRow xs

addLastPlus::Row->Row
addLastPlus x = init x ++ [init(last x) ++ " "]


{---------------------------------------------------------------------}
{----------------------------         --------------------------------}
{---------------------------------------------------------------------}

project::[String]->Table->Table
project [] _ = []
project _ [] = []
project x y = transpose (compareColumns x (transpose y))

compareColumns::[String]->Table->Table
compareColumns [] _ = []
compareColumns _ [] = []
compareColumns (x:xs) y = (findColumn x y) : compareColumns xs y

findColumn::String->Table->[String]
findColumn "" _ = []
findColumn _ [] = []
findColumn x (ys:yss) | eqList eqString [x] [head(ys)]  = ys
                      | otherwise = findColumn x yss

{---------------------------------------------------------------------}
{----------------------------        ---------------------------------}
{---------------------------------------------------------------------}

select::String->(String->Bool)->Table->Table
select y eq (xs:xss) = xs : (selection y eq (xs:xss))
       
--    
selection::String->(String->Bool)->Table->Table
selection y eq x  = transpose (project (checkElement (concat (project [y] x)) eq) (transpose (x)))

checkElement::Column->(String->Bool)->Column
checkElement [] f = []
checkElement (x:xs) f | f x = [x] ++ checkElement xs f
                      | otherwise = checkElement xs f

{---------------------------------------------------------------------}
{----------------------------      -----------------------------------}
{---------------------------------------------------------------------}

join::Table->Table->Table
join x y  = transpose (removeColumn (transpose x) (begin x y) ++ (transpose y) )

removeColumn::Table->Column->Table
removeColumn [] y      = []
removeColumn (x:xs) [] = []
removeColumn (x:xs) y  | eqList eqString x y = removeColumn xs y
                       | otherwise           = x : removeColumn xs y

begin::Table->Table->Column
begin x y = join' (transpose x) (transpose y)

join'::Table->Table->Column
join' (x:xs) [] = []
join' []     y  = []
join' (x:xs) y  = findDouble x y ++ join' xs y

findDouble::Column->Table->Column
findDouble [] (y:ys) = []
findDouble x      [] = []
findDouble x  (y:ys) | eqList eqString x y = x
                     | otherwise           = findDouble x ys


