data Prop

   = En [Prop]     --                
   | Of [Prop]     --                
   | Niet Prop
   | Prop :-> Prop --                  
   | Var String    --          
   | Bool Bool     --           

type Bedeling = [String]

evalueer :: Prop -> Bedeling -> Bool
evalueer (En props)    bedeling = all (\prop -> evalueer prop bedeling) props
evalueer (Of props)    bedeling = any (\prop -> evalueer prop bedeling) props
evalueer (Niet prop)   bedeling = not (evalueer prop bedeling)
evalueer (Var string)  bedeling = elemBy eqString string bedeling
evalueer (Bool bool)   _        = bool
--                  -                                                                    

vervulbaar :: Prop -> [Bedeling]
vervulbaar (Var stringA :-> Var stringB) = ([stringA] ++ [stringB]) : [stringB]: [[]]

--    
toon :: Prop -> String
toon (En props)        = " " ++ (drop 4 (concatMap ("     " ++) (map (\prop -> toon prop) props))) ++ " "
toon (Of props)        = " " ++ (drop 4 (concatMap ("     " ++) (map (\prop -> toon prop) props))) ++ " "
toon (Niet prop)       = " " ++ (toon prop)
toon (propA :-> propB) = " " ++ (toon propA) ++ "    " ++ (toon propB) ++ " "
toon (Var string)      = string
toon (Bool bool)       | bool      = "    "
                       | otherwise = "     "

--          
tautologie :: Prop -> Bool
tautologie props = all (evalueer props) (subs(zoekVar props))

--            
contradictie :: Prop -> Bool
contradictie props = not (any (evalueer props) (subs(zoekVar props)))

--            
equivalent :: Prop -> Prop -> Bool
equivalent propsA propsB = eqList eqBool (map (evalueer propsA) bedeling) (map (evalueer propsB) bedeling)
                         where bedeling = subs((zoekVar propsA) ++ (zoekVar propsB))

--        
deMorgan :: Prop -> Prop
deMorgan (Niet (En props)) = (Of (map (\prop -> deMorgan prop) props))
deMorgan (Niet (Of props)) = (En (map (\prop -> deMorgan prop) props))
deMorgan (Var string)             = (Niet(Var string))
deMorgan props                    = props

--                                
subs :: [a] -> [[a]]
subs [] = [[]]
subs (x:xs) = map (x:) subsxs ++ subsxs
            where subsxs = subs xs

--                                    
zoekVar :: Prop -> [String]
zoekVar (En props)    = concatMap (\prop -> zoekVar prop) props
zoekVar (Of props)    = concatMap (\prop -> zoekVar prop) props
zoekVar (Niet prop)   = zoekVar prop
zoekVar (Var string)  = [string]
zoekVar (Bool _)      = []
zoekVar (propA :-> propB) = (zoekVar propA) ++ (zoekVar propB)



--      
--                  -      
--                       

ontleed :: String -> Prop
ontleed string = split (words string)

split :: [String] -> Prop
split (x:xs:xss) | eqString "   " xs         = En [Var x, (split xss)]
                 | eqString "   " xs         = Of [Var x, (split xss)]
                 | otherwise                 = Var x
split [x]        | eqString " "   (take 1 x) = (Niet (Var (tail x)) )
                 | otherwise                 = Var x

--            -       
--                                     



--                                                      
--            -             
--                        
--                        
--                          
--                         



