module CommonIO where

import IO
import System.Time

-- strict evaluation of contents of file for optimised reading
-- handle is explicitely closed so unlimited read files can be evaluated
getContentsStrict :: FilePath -> IO String
getContentsStrict path =
   do handle <- openFile path ReadMode
      str <- hGetContents handle
      str `seq` hClose handle  -- first evaluate the complete string
      return str

interactIO fun = do
  hSetBuffering stdin  LineBuffering
  hSetBuffering stdout LineBuffering
  interact fun

{-

Daan ways of handling strictness, from lvm/src/lib/common/Standard.hs
      
----------------------------------------------------------------
-- strictness
----------------------------------------------------------------
strict :: (a -> b) -> a -> b
strict f x    = f $! x

-}