module Statistics.DescriptiveAnalysis (
     module Statistics.DescriptiveAnalysis.DescriptiveKeyAC
   , module Statistics.DescriptiveAnalysis.KeyHistoryListImpl
   , module Statistics.DescriptiveAnalysis.PrimGroupingAC
   , runAnalysisGeneric
   , Statistics.DescriptiveAnalysis.PrimAC.flattenAnalysis
   , module Statistics.BasicTypes
   )
   where

-- re-export of default Descriptive Analysis Combinators and a default key
-- for convenience of only importing Statistics.DescriptiveAnalysis and having the different approaches to handling analyses at hand

import Statistics.DescriptiveAnalysis.DescriptiveKeyAC
import Statistics.DescriptiveAnalysis.KeyHistoryListImpl
import Statistics.BasicTypes

-- seperate Grouping functions
import Statistics.DescriptiveAnalysis.PrimGroupingAC

import Statistics.DescriptiveAnalysis.PrimAC (flattenAnalysis)
import qualified Statistics.DescriptiveAnalysis.PrimAC

runAnalysisGeneric = Statistics.DescriptiveAnalysis.PrimAC.runAnalysis