module Statistics.DescriptiveAnalysis.KeyStringImpl where

import Statistics.DescriptiveAnalysis.KeyableAC (
                                                                Keyable
                                                              , startkey
                                                              , combine
                                                          )

import Statistics.DescriptiveAnalysis.DescriptiveKeyAC   ( DescriptiveKey
                                                              , basicKey
                                                              , groupKey
                                                              , mappingkey
                                                              , aggregateKey
                                                              , selectGrpKey
                                                              , tupleKey
                                                              , filteringkey
                                                              )

import Data.Typeable

instance Keyable String where
   startkey = ""
   combine orikey newkey = if (null orikey)
                              then newkey
                              else (++) orikey $ (++) "; " newkey  -- key should be readable from left to right

instance DescriptiveKey String where
   basicKey descr           =  "Basic analysis " ++ show descr
   aggregateKey descr keys  =  "Aggregated calculation: " ++ descr ++ " based on " ++ show keys
   groupKey eitherval  =
      either  (\value -> "Grouping analysis " ++ (showType value) ++ ": " ++ show value ++ "")
              (\(str1, str2) -> "Grouping analysis " ++ show str1 ++ ": " ++ show str2 ++ "")
              eitherval
   selectGrpKey descr       = "Select analysis " ++ show descr
   tupleKey basekey ana1key ana2key =
         "Tupled analysis (" ++ basekey ++ ", " ++ ana1key ++ ", " ++ ana2key ++ ")"