module Statistics.Ordering where

import Data.List

sortUnder :: (a -> a -> Ordering) -> [(a,b)] -> [(a,b)]
sortUnder aord = sortBy (\(y1,_) (y2,_) -> aord y1 y2)

listOrdering :: Eq a => [a] -> a -> a -> Ordering
listOrdering elms e1 e2 = 
   case (elemIndex e1 elms, elemIndex e2 elms) of
      (Just i1, Just i2) -> compare i1 i2
      (Just i1, Nothing) -> LT
      (Nothing, Just i2) -> GT
      _                  -> EQ


----
-- Ordering, from Stat/DAC/KeyHistoryListImpl.hs
----

sortByFstElm :: Ord a => [(a,b)] -> [(a,b)]
sortByFstElm = sortBy (\e1 e2 -> compare (fst e1) (fst e2))

sortBySndElm :: Ord b => [(a,b)] -> [(a,b)]
sortBySndElm = sortBy (\e1 e2 -> compare (snd e1) (snd e2))