module Thesis.AnalysisPredefined where

-- Defined analyses and researches
import Thesis.Metrics
import Thesis.Research.Common
-- import Thesis.Research.ProgramCharacteristics
import Thesis.Research.CheckLogDate
import Thesis.Research.ModuleLengthResearch
import Thesis.Research.TypingTillCodeResearch
import Thesis.Research.PhaseResearch
import Thesis.Research.LineBasedInterpretationResearch 
import Thesis.Research.HintRateResearch
import Thesis.Research.CompilationDistribution

-- > analyze -X shows all researches
{-
predefAnalyses :: [([Char],
                    Statistics.Presentation.MarkUpDoc.OutputFormat
                    -> [(Statistics.DescriptiveAnalysis.KeyHistoryListImpl.KeyHistory,
                         [Thesis.Helium.Logging.Logging])]
                    -> FilePath
                    -> IO ())]
                    -}

predefAnalyses = [
     ("Phases per week overall", phaseResearchOverall)
   , ("Phases per week per student", phaseResearchPerStudent)
   , ("Module length / Lines of Code (LOC)", moduleLengthResearchOverall)
   , ("Module length / Lines of Code (LOC) per student", moduleLengthResearchPerStudent)
   , ("Line based source interpretation", linebasedResearchOverall)
   , ("Line based source interpretation per student", linebasedResearchPerStudent)
   , ("Number of loggings / time from first T to C", typingTillCodeResearchOverall)
   , ("Number of loggings / time from first T to C per student", typingTillCodeResearchPerStudent)
   , ("Compilation time difference distribution", runOld complDistResearch)
   , ("Hint ratio, overall and per week", runOld hintRatioResearch)
   , ("Hint effectiveness research - overall", typingTillCodeResearchOverall)
--   , ("Check date parsing of each logging", runOld chkLogDateResearch)
   ]

-- run analysis with older signature, being the output path as last parameter
runOld research format fp values = research format values fp
