module Thesis.CombinatorExamples where

import Statistics.DescriptiveAnalysis.PrimAC
import qualified Statistics.BasicTypes
-- import Statistics.Representation.DataInfo
import Statistics.Presentation
import Statistics.SummaryMeasures

import Thesis.Helium.LogfileParser
import Thesis.Helium.Logging

import Thesis.Helium.Logging
import Grouping
import qualified Thesis.Grouping.Logging as LoggingGrouping (
                       --   groupPerSession_
                          groupPerWeekFromSeq_
                        , groupPerWeek_
--                        , groupPerPhase
                        , groupPerPhase_
                        )
-- import Thesis.Metrics
-- import Data.Typeable

-- examples from Section 4. combinator discuss

-- for IO like operations
import Thesis.Research.ResearchGeneration hiding (generateResearches)
import qualified Thesis.Research.ResearchGeneration

import Auxilary
-- import Distribution.Compat.FilePath
-- import System.Directory(createDirectoryIfMissing)

-- import System.Time

groupPerPhase :: Analysis String [Logging] String [Logging]
groupPerPhase = groupAnalysis (\val oldkey -> oldkey ++ "; " ++ (show $ phase val)) (groupAllUnder phase)
   -- groupPerValueUnder phase

-- groupAllUnder :: Eq b => (a -> b) -> [a] -> [[a]]

-- not as usefull, as the above, since that one, will more likely to produce standard output
-- this is because the grouping info/subject is encapsulated in the key, and used for later reference
numberOfLoggingsPerPhase :: Analysis String [Logging] String (Int)
numberOfLoggingsPerPhase = 
--    (basicAnalysis (++ "; phase" ++ (phase . head) <&> length {-calculateSize-}) <.> groupPerPhase
       (basicAnalysis (++ "; number of logs") length {-calculateSize-}) <.> groupPerPhase

-- calculating avg (if tupled only once) now should go like:
averageOverall :: Analysis String (Int) String (Maybe Float)
averageOverall = aggregateAnalysis (const "avg") (mean)
-- averageOverall = aggregateAnalysis (const "avg") (mean . {-complementData .-} (map snd))

avgNoLogsPerPhase :: Analysis String [Logging] String (Maybe Float)
avgNoLogsPerPhase = averageOverall <.> numberOfLoggingsPerPhase

avgNoLogsPerPhaseIso :: Analysis String [Logging] String (Maybe Float)
avgNoLogsPerPhaseIso =
      isolateAnalysis averageOverall
  <.> numberOfLoggingsPerPhase

{-
numberOfLoggingsPerPhasePerGrp :: Analysis key [Logging] key [(Phase,Int)]
numberOfLoggingsPerPhasePerGrp = 
    isolateAnalysis $ aggregateAnalysis "" id <.> (basicAnalysis "phase" (phase . head) <&> length{-calculateSize-}) <.> groupPerPhase

-}