module Thesis.Grouping.LexerToken where

import Grouping
-- import Grouping.Similar
import Thesis.HeliumUniversal.LexerToken

{-
here?
-}

groupSimilarToken_ :: [Token] -> [[Token]]
groupSimilarToken_ = groupSimilar

groupSimilarLexeme_ :: [Lexeme] -> [[Lexeme]]
groupSimilarLexeme_ = groupSimilar

groupSimilarLexeme :: [Lexeme] -> [(Lexeme, [Lexeme])]
groupSimilarLexeme = enTupleGroup id . groupSimilar

groupPerLexeme = groupSimilarLexeme

----
-- Specification of similarity of lexertokens for grouping
----

instance Similar Token where
   similar (sourcePos1, lexeme1)
           (sourcePos2, lexeme2) = similar lexeme1 lexeme2


instance Similar Lexeme where
   similar (LexChar            string1)
           (LexChar            string2) = True
   similar (LexString          string1)
           (LexString          string2) = True
   similar (LexInt             string1)
           (LexInt             string2) = True
   similar (LexFloat           string1)
           (LexFloat           string2) = True

   similar (LexVar             string1)
           (LexVar             string2) = True
   similar (LexVarSym          string1)
           (LexVarSym          string2) = True
   similar (LexCon             string1)
           (LexCon             string2) = True
   similar (LexConSym          string1)
           (LexConSym          string2) = True
   
   similar (LexKeyword         string1)
           (LexKeyword         string2) = True
   similar (LexResVarSym       string1)
           (LexResVarSym       string2) = True
   similar (LexResConSym       string1)
           (LexResConSym       string2) = True
   similar (LexSpecial         char1)
           (LexSpecial         char2) = True

   similar (LexInsertedOpenBrace)
           (LexInsertedOpenBrace) = True
   similar (LexInsertedCloseBrace)
           (LexInsertedCloseBrace) = True
   similar (LexInsertedSemicolon)
           (LexInsertedSemicolon) = True
   
   similar (LexEOF) (LexEOF) = True
   similar l1 l2             = False
