module Thesis.Helium.LoggingPP where

import Thesis.Helium.Logging
import Thesis.HeliumUniversal.HeliumErrors
import Auxilary


import System.Time

{-
Todo:
- pp of helium errors in seperate file

-}



-- group30:C:1.1 (Mon Mar 10 09:19:12  2003)::group30/2003-02-12@14_22_31_491/Nieuw.hs
ppLogging :: Logging -> String
ppLogging log = -- sepList ":"
   (ppUsername $ username log) ++ ":" ++
   (ppPhase $ phase log) ++ (ppStaticErrorCodes $ staticErrorCodes log) ++ ":" ++
   (ppHeliumVersion $ heliumVersion log) ++ "::" ++
   --(ppLoggingDate loggingDate) ++ ":" ++
   (ppPath $ logPath log) 
   --(ppExts $ extraLoggingInfo log ) -- ++ "\n", not necessary, unlines does this

-- Pp function for show in grid
ppLoggingSplit :: Logging -> [String]
ppLoggingSplit (Log username phase heliumVersion path loggingDate staticErrorsLogfile exts)
   = [ ppUsername username
     , ppPhaseLong phase
     , ppLoggingDate loggingDate
     , ppPath path
--     , ppStaticErrors staticErrorsLogfile
--     , ppExts exts
     ]

ppUsername (Username username)= username

ppPhase ph = case ph of
                Lexical -> "L"
                Parsing -> "P"
                ResolOp -> "R"
                Static-> "S"
                Typing -> "T"
                CodeGen -> "C"
                InternalErr -> "I"

ppHeliumVersion helver = heliumVersionNumber helver ++ " (" ++ buildDateRef helver ++ ")"

ppStaticErrorCodes = sepList ";"

ppPhaseLong ph = show ph 

--ppCompiledate (Path basedir userDir loggingDir sourceFile) = loggingDir
--ppCompiledate (Path basedir userDir loggingDir sourceFile) = loggingDir


ppLoggingDate datetime ={-
Todo:
- pp of helium errors in seperate file

-} calTimeToString datetime

ppPath (Path basDir userDir loggingDir sourceFile) = formatPath [basDir, userDir, loggingDir, sourceFile]

ppExtraLoggingInfo :: ExtraLoggingInfo -> String
ppExtraLoggingInfo = show

ppTimeDiff = timeDiffToString

-- un logging like data type?

ppLogSimple :: Logging -> String
ppLogSimple = (++"\n") . ppPath . logPath

ppHeliumError :: HeliumError -> String
ppHeliumError heliumerror =
         case heliumerror of
            LexerPhError   errors -> concatMap ppHeliumErrorCompleteFull errors
            ParsePhError   errors -> concatMap ppHeliumErrorCompleteFull errors
            ImportPhError  errors -> concatMap ppHeliumErrorCompleteFull errors
            StaticPhError  errors -> concatMap ppHeliumErrorCompleteFull errors
            TypePhError    errors -> concatMap ppHeliumErrorCompleteFull errors
            otherwise -> error "unexpected error value when pretty printing a HeliumError"
        where

ppHeliumErrorCompleteFull e =
   {- (++"\n") originalMessage has an ending linefeed (in case of ParseError) -}
   (originalMessage e) ++ (++"\n") (show $ heliumErrorData e)

ppHeliumErrorCompleteOnlyOriMsg e =
   (++"\n") (originalMessage e)

ppHeliumErrorCompleteOnlyData e =
   (++"\n") (show $ heliumErrorData e)

ppHeliumErrorLog :: (Logging, HeliumError) -> String
ppHeliumErrorLog (log, heliumerror) =
         case heliumerror of
            LexerPhError   errors -> (++) ((ppPath $ logPath log)++"\n") (concatMap originalMessage errors)
            ParsePhError   errors -> (++) ((ppPath $ logPath log)++"\n") (concatMap originalMessage errors)
            ImportPhError  errors -> (++) ((ppPath $ logPath log)++"\n") (concatMap originalMessage errors)
            StaticPhError  errors -> (++) ((ppPath $ logPath log)++"\n") (concatMap originalMessage errors)
            TypePhError    errors -> (++) ((ppPath $ logPath log)++"\n") (concatMap originalMessage errors)
            otherwise -> error "unexpected error value when pretty printing a HeliumError"
{-
ppHeliumToken :: Token -> String
ppHeliumToken (sourcePos ->
-}