module HeliumInstrumentation.Hierar.CallHelium where

-- move to main dir

-- for ana impl
import Logging
import PrettyPrinter
-- import Statistics.AnalysisImplementations(getLoggingLocation)
import System.Environment
import System.IO.Unsafe(unsafePerformIO)

import Control.Exception
import System.Exit

import Prelude hiding (catch)

-- tmp
import Auxilary (traceVal)


import Data.Maybe
import Control.Monad (guard)
import Data.IORef

import HeliumInstrumentation.Hierar.Utils -- should Argsit be in instr_ heliu dir?
--import Helium1v5.Src.HeliumNT.Src.Parser.LexerMessage

--import Helium1v1.Src.HeliumNT.Src.Main.Args 
--import qualified Helium1v0.Src.HeliumNT.Src.Main.Compile as helium1v0
import qualified Helium1v1.Src.HeliumNT.Src.Main.Main as Helium1v1
--import qualified Helium1v1.Src.HeliumNT.Src.Main.Compile as Helium1v1C
{-
import qualified Helium1v1A.Src.HeliumNT.Src.Main.Compile as Helium1v1A
import qualified Helium1v1.Src.HeliumNT.Src.Main.Compile as helium1vHC.compile1
import qualified Helium1v1v1.Src.HeliumNT.Src.Main.Compile as helium1v1v1

import qualified Helium1v1v2.Src.HeliumNT.Src.Main.Compile as helium1v1v2
import qualified Helium1v2.Src.HeliumNT.Src.Main.Compile as helium1v2
import qualified Helium1v2v1.Src.HeliumNT.Src.Main.Compile as helium1v2v1
import qualified Helium1v2v2.Src.HeliumNT.Src.Main.Compile as helium1v2v2 -}
--import qualified Helium1v5.Src.HeliumNT.Src.Main.Compile as Helium1v5
-- import qualified Helium1v5v1.Src.HeliumNT.Src.Main.Compile as helium1v5v1

import Logging
import HeliumUniversal.Args
import Settings

{-
helium1v0   = HeliumVersion "1.0"   ""
helium1v1   = HeliumVersion "1.1"   "Mon-Mar-10-09_19_12--2003"
helium1v1A  = HeliumVersion "1.1A"  ""
helium1v1v1 = HeliumVersion "1.1.1" ""
helium1v1v2 = HeliumVersion "1.1.2" ""
helium1v2   = HeliumVersion "1.2"   ""
helium1v2v1 = HeliumVersion "1.2.1" ""
helium1v2v2 = HeliumVersion "1v2.2" ""
helium1v5   = HeliumVersion "1.5"   ""
helium1v5v1 = HeliumVersion "1.5.1" ""

heliums :: [HeliumVersion]
heliums = [ helium1v0, helium1v1, helium1v1A, helium1v1v1 ]

-- options, modeling the analysis options of each helium compiler
data AnalysisOption =
      ErrorAnalysis
    | WarningAnalysis
    | TokenAnalysis
    | ASTAnalysis
 deriving (Eq, Show, Read)

toCmdLine :: AnalysisOption -> String
toCmdLine opt =
   case opt of
      ErrorAnalysis   -> "--erroranalysis"
      WarningAnalysis -> "--warninganalysis"
      TokenAnalysis   -> "--tokenanalysis"
      ASTAnalysis     -> "--astanalysis"
      -}

-- import Main.Args for Options and compile
--type CompilerCompileCall = String -> [Option] -> [String] -> {- [String] -> hel 1.5 -} IO ()
--heliumCompiler2 :: HeliumVersion -> CompilerCompileCall
--heliumCompiler2 _ = Helium1v1C.compile

{-

mistakenCompilerCompileCall :: HeliumVersion -> CompilerCompileCall
mistakenCompilerCompileCall helver =
   (\path opts strs1 -> do ioError (userError ("Compiler " ++ (show helver) ++ " not supported to be called"))
                           return ()
   )
-}

type CompilerMainCall = IO ()

heliumCompiler :: HeliumVersion -> CompilerMainCall
heliumCompiler helver | helver == helium1v0   = undefined
                      | helver == helium1v1   = Helium1v1.main
                      | helver == helium1v1A  = Helium1v1.main
                      | helver == helium1v1v1 = Helium1v1.main
                      | helver == helium1v1v2 = Helium1v1.main
                      | helver == helium1v2   = Helium1v1.main
                      | helver == helium1v2v1 = Helium1v1.main
                      | helver == helium1v2v2 = Helium1v1.main
                      | helver == helium1v5   = Helium1v1.main
                      | helver == helium1v5v1 = Helium1v1.main
                      | otherwise = ioError (userError ("Called compiler " ++ (show helver) ++ " is not supported."))

-- Call Helium Compiler and raise error to skip further compilation and retrieve result from IORef
-- Types should be provide to prevent a segmentation errorpath
doHeliumAnalysis :: HeliumVersion -> Logging2 -> [AnalysisOption] -> IO (Maybe String)  -- LexerError
doHeliumAnalysis helver log opts = call callCompiler handleResult
   where
      call :: IO a -> (String -> IO a) -> IO a -- IO a -> (Bool -> IO a) -> IO a
      call = catchJust -- :: (Exception -> Maybe b) -> IO a -> (b -> IO a) -> IO a
         (\exception ->
            case exception of
               NoMethodError str ->
                     if (instrumentedErrorMessage == (take (length instrumentedErrorMessage) str))
                        then return (drop (length instrumentedErrorMessage) str)
                        else do throw exception   -- reraise real NoMethodError's
                                return ""
                                
               ExitException exitCode -> if (exitCode == ExitFailure 1)
                                         then
                                            throw instrumentationPointNotFoundError
                                         else
                                            throw exception

               otherwise -> throw exception   -- reraise other errors
         )
      compiler = heliumCompiler helver
      callCompiler =
            do --compiler (ppPath $ logpath $ log) [Analysis] [] -- Compile.Compile call
               withArgs ((map toCmdLine opts)++[(ppPath $ logpath $ log)]) compiler
               throwIO instrumentationPointNotFoundError
               return Nothing
      handleResult
         = (\res -> if (res /= "")
                           then do -- putStr ("Instrumented result: \"" ++ res ++ "\"")
                                   return (Just res)
                           else
                              do throwIO instrumentedFailedError
                                 return Nothing
           )

{-
doHeliumCallAnalysisIORef :: IO a -> Logging2 -> IO (Maybe a)  -- LexerError
doHeliumCallAnalysisIORef compiler log = call heliumCompiler handleResult
   where            -- pvk showErrorsAndExit [lexError] 1 options
            if ((AnalysisOption) `elem` options)
               then analyseLexErrors lexError -- instrumentation inclusion
               else showErrorsAndExit [lexError] 1 options
      call :: IO a -> (Bool -> IO a) -> IO a
      call = catchJust -- :: (Exception -> Maybe b) -> IO a -> (b -> IO a) -> IO a
         (\(NoMethodError str) ->
            if (str == take (length instrumentedErrorMessage) instrumentedErrorMessage)
               then return (drop (length instrumentedErrorMessage) instrumentedErrorMessage)
               else do throw (NoMethodError str)   -- reraise real NoMethodError's
                       return ""
         )
      heliumCompiler =
            do compiler (ppPath $ logpath $ log) [AnalysisOption] [] []
               throwInstrumentedFailedError
               return Nothing
      handleResult
         = (\succes -> if succes
                           then do res <- (readIORef analysisSubject)
                                   putStr "Instrumented succeeded"
                                   return (res)
                           else
                              do throwInstrumentedFailedError
                                 return Nothing
           )
-}

--throwInstrumentedFailedError :: IO a
--throwInstrumentedFailedError = ioError $ userError "Instrumented helium call failed. Instrumentation point found, but information is not returned or parseable."
instrumentedFailedError :: a
instrumentedFailedError = error "Instrumented helium call failed. Instrumentation point found, but information is not returned."

--throwInstrumentationPointNotFoundError :: IO a
--throwInstrumentationPointNotFoundError = ioError $ userError "Instrumented helium call failed. Instrumentation point not found"
instrumentationPointNotFoundError :: a
instrumentationPointNotFoundError = error "Instrumented helium call failed. Instrumentation point not found"

analyseLexErrorsNew :: (Show a) => a -> Int
analyseLexErrorsNew val = length (show val)
