module Thesis.HeliumUniversal.Args where

import System.Exit
import Thesis.Helium.Logging

-- options, modeling the analysis options of each helium compiler
data AnalysisOption =
      ErrorAnalysis
    | WarningAnalysis
    | TokenAnalysis
    | ASTAnalysis
 deriving (Eq, Show, Read)

toCmdLine :: AnalysisOption -> String
toCmdLine opt =
   case opt of
      ErrorAnalysis   -> "--erroranalysis"
      WarningAnalysis -> "--warninganalysis"
      TokenAnalysis   -> "--tokenanalysis"
      ASTAnalysis     -> "--astanalysis"

--mapToCmdLine :: [AnalysisOption] -> String
mapToCmdLine = concatMap (\opt -> " " ++ (toCmdLine opt) ++ " ")

{- implemented in InstrumentationUtils.hs

noAnalysis :: [AnalysisOption] -> Bool
noAnalysis = undefined

-}