module Thesis.HeliumUniversal.BasicTypes where

-- sub types used by other helium universal types.
-- these types do not differ or change for any helium compiler version

import Data.Typeable

class HeliumCustomShow a where
   heliumCustomShow :: a -> String

-----------------------------------------------------------
-- Source Positions, a file name, a line and a column.
-- upper left is (1,1), identical in all helium/parsec sources
-----------------------------------------------------------                         
type SourceName     = String
type Line           = Int
type Column         = Int

data SourcePos      = SourcePos SourceName !Line !Column
                     deriving (Eq, Ord, Show, Read, Typeable)

    
-- Name is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5v1/Src/HeliumNT/Src/Syntax/UHA_Syntax.hs:130
data Name
    = Name_Identifier Range Strings String |
      Name_Operator Range Strings String |
      Name_Special Range Strings String
    deriving (Show, Read, Eq, Typeable)

-- Names -------------------------------------------------------
type Names = [(Name)]

-- Range is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5v1/Src/HeliumNT/Src/Syntax/UHA_Syntax.hs:163
data Range = Range_Range Position Position
    deriving (Show, Read, Eq, Typeable)
    
-- Position is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5v1/Src/HeliumNT/Src/Syntax/UHA_Syntax.hs:153
data Position = Position_Position String Int Int | Position_Unknown
    deriving (Show, Read, Eq, Typeable)

-- Strings is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5v1/Src/HeliumNT/Src/Syntax/UHA_Syntax.hs:185
type Strings = [String]