module Thesis.HeliumUniversal.ParseError where

import Thesis.HeliumUniversal.BasicTypes (SourcePos)
import Data.Typeable

-----------------------------------------------------------
-- Parse Errors -- identical for all Heliums
-----------------------------------------------------------

---------------------------------------
data ParseError     = ParseError !SourcePos [Message]
    deriving (Show, Read, Eq, Typeable)

-----------------------------------------------------------
-- Parse Messages -- identical for all Heliums, not the same as Message in Type Error
-----------------------------------------------------------                         
data Message        = SysUnExpect !String   --library generated unexpect            
                    | UnExpect    !String   --unexpected something
                    | Expect      !String   --expecting something
                    | Message     !String   --raw message
                    deriving (Show, Read, Eq)
