module Thesis.HeliumUniversal.TypeError where

import Thesis.HeliumUniversal.BasicTypes
import Data.Typeable

{-
import qualified Helium1v1.Src.HeliumNT.Src.Staticanalysis.Messages.TypeErrors as Helium1v1TypeErrors
import qualified Helium1v2.Src.HeliumNT.Src.Staticanalysis.Messages.TypeErrors as Helium1v2TypeErrors
import qualified Helium1v5.Src.HeliumNT.Src.Staticanalysis.Messages.TypeErrors as Helium1v5TypeErrors
-}

import qualified Thesis.HeliumUniversal.TypeError.Helium1v1TypeError as Helium1v1TypeError
import qualified Thesis.HeliumUniversal.TypeError.Helium1v2TypeError as Helium1v2TypeError
import qualified Thesis.HeliumUniversal.TypeError.Helium1v5TypeError as Helium1v5TypeError

data TypeError = Helium1v1LikeTypeError Helium1v1TypeError.TypeError  -- same for Helium 1.1, 1.1A, 1.1.1, 1.1.2
               | Helium1v2LikeTypeError Helium1v2TypeError.TypeError  -- same for Helium 1.2, 1.2.1, 1.2.2
               | Helium1v5LikeTypeError Helium1v5TypeError.TypeError  -- same for Helium 1.5, 1.5.1
     deriving (Eq, Show, Read, Typeable)


-------------------------------------------------------------
-- Type Errors, based on Helium1v1.Src.HeliumNT.Src.Staticanalysis.Messages.TypeErrors
-------------------------------------------------------------
--type TypeErrors = [TypeError]
{-
data TypeError = Helium1v1TypeError Helium1v1TypeErrors.TypeError  -- same for Helium 1.1, 1.1A, 1.1.1, 1.1.2
               | Helium1v2TypeError Helium1v2TypeErrors.TypeError  -- same for Helium 1.2, 1.2.1, 1.2.2
               | Helium1v5TypeError Helium1v5TypeErrors.TypeError  -- same for Helium 1.5, 1.5.1
--     deriving (Eq, Show, Read, Typeable)
-}



{-
data Helium1v1vXTypeError  =
                  TypeErrorUniversalDatatypes
                     Range                    -- range of the error
                     Helium1v1vXMessageBlock  -- oneliner-message
                     TypeErrorTable           -- Hugs-like table
        import HeliumUniversal.UniversalDatatypes
import Data.Typeable type            Helium1v1vXTypeErrorInfos           -- extra info (e.g. hints)

                | CustomTypeError
                     [Range]
                     Message

data Helium1v1vXTypeErrorTable = UnificationErrorTable
                         [(String, Helium1v1vXMessageBlock)]     -- sources to be reported
                         (Either Tp TpScheme) -- type or typescheme of n.t. or subterm of n.t.
                         (Either Tp TpScheme) -- conflicting type or expected type
                         
                    | NotGeneralEnoughTable           
                         Tree                 -- expression
                         TpScheme             -- declared type
                         TpSch-------------------------------------------------------------
-- Type Errors, based on Helium1v1.Src.HeliumNT.Src.Staticanalysis.Messages.TypeErrors
-------------------------------------------------------------
--type TypeErrors = [TypeError]
{-type
data TypeError = Helium1v1TypeError Helium1v1TypeErrors.TypeError  -- same for Helium 1.1, 1.1A, 1.1.1, 1.1.2
               | Helium1v2TypeError Helium1v2TypeErrors.TypeError  -- same for Helium 1.2, 1.2.1, 1.2.2
               | Helium1v5TypeError Helium1v5TypeErrors.TypeError  -- same for Helium 1.5, 1.5.1
--     deriving (Eq, Show, Read, Typeable)
-}
-}
{-
data Helium1v1vXTypeError  =
                  TypeError
                     Range                    -- range of the error
                     Helium1v1vXMessageBlock  -- oneliner-message
                     TypeErrorTable           -- Hugs-like table
        import HeliumUniversal.UniversalDatatypes
import Data.Typeable             Helium1v1vXTypeErrorInfos           -- extra info (e.g. hints)

                | CustomTypeError
                     [Range]
                     Message

data Helium1v1vXTypeErrorTable = UnificationErrorTable
                         [(String, Helium1v1vXMessageBlock)]     -- sources to be reported
                         (Either Tp TpScheme) -- type or typescheme of n.t. or subterm of n.t.
                         (Either Tp TpScheme) -- conflicting type or expected type
                         
                    | NotGeneralEnoughTable           
                         Tree                 -- expression
                         TpScheme             -- declared type
                         TpScheme             -- inferred type

type Helium1v1vXTypeErrorInfos = [TypeErrorInfo]
data Helium1v1vXTypeErrorInfo  = TypeErrorHint String Helium1v1vXMessageBlock
                    | IsFolkloreTypeError
                    | HasDocumentationLink String
import HeliumUniversal.UniversalDatatypes
import Data.Typeable
-- Helium 1.1.X sub types
type Helium1v1vXMessage       = [Helium1v1vXMessageLine] 

data Helium1v1vXMessageLine   =
                     MessageOneLiner  Helium1v1vXMessageBlock
                   | MessageTable     [(Helium1v1vXMessageBlock, Helium1v1vXMessageBlock)]
                   | MessageHints     String Helium1v1vXMessageBlocks

type Helium1v1vXMessageBlocks= [Helium1v1vXMessageBlock]
data Helium1v1vXMessageBlock  = MessageString       String
                   | MessageRange        Range
                   | MessageType         Tp
                   | MessageTypeScheme   TpScheme
                   | MessageInfoLink     String
                   | MessageOneLineTree  OneLiner.Tree
                   | MessageCompose      Helium1v1vXMessageBlocks
-}
             -- inferred type
{-
type Helium1v1vXTypeErrorInfos = [TypeErrorInfo]
data Helium1v1vXTypeErrorInfo  = TypeErrorHint String Helium1v1vXMessageBlock
                    | IsFolkloreTypeError
                    | HasDocumentationLink String
import HeliumUniversal.UniversalDatatypes
import Data.Typeable
-- Helium 1.1.X sub types
type Helium1v1vXMessage       = [Helium1v1vXMessageLine] 

data Helium1v1vXMessageLine   =
                     MessageOneLiner  Helium1v1vXMessageBlock
                   | MessageTable     [(Helium1v1vXMessageBlock, Helium1v1vXMessageBlock)]
                   | MessageHints     String Helium1v1vXMessageBlocks

type Helium1v1vXMessageBlocks= [Helium1v1vXMessageBlock]
data Helium1v1vXMessageBlock  = MessageString       String
                   | MessageRange        Range
                   | MessageType         Tp
                   | MessageTypeScheme   TpScheme
                   | MessageInfoLink     String
                   | MessageOneLineTree  OneLiner.Tree
                   | MessageCompose      Helium1v1vXMessageBlocks
-}
