module Thesis.HeliumUniversal.TypeError.Helium1v2TypeError where

import Thesis.HeliumUniversal.BasicTypes
import Data.Typeable

-- TypeError is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/HeliumNT/Src/Staticanalysis/Messages/TypeErrors.hs:21
data TypeError
    = TypeError [Range] [MessageLine] [(String, MessageBlock)] [TypeErrorHint]
     deriving (Eq, Show, Read, Typeable)

-- Range is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/HeliumNT/Src/Syntax/UHA_Syntax.hs:16
{-
-- Position defined in HeliumBasicTypes
-- shared type

data Range
    = Helium1v2.Src.HeliumNT.Src.Syntax.UHA_Syntax.Range_Range Helium1v2.Src.HeliumNT.Src.Syntax.UHA_Syntax.Position Helium1v2.Src.HeliumNT.Src.Syntax.UHA_Syntax.Position
-}
-- MessageLine is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/HeliumNT/Src/Staticanalysis/Messages/Messages.hs:28
data MessageLine
    = MessageOneLiner MessageBlock |
      MessageTable [(MessageBlock, MessageBlock)] |
      MessageHints String MessageBlocks
     deriving (Eq, Show, Read, Typeable)


data MessageBlock
    = MessageString String |
      MessageRange Range |
      MessageType TpScheme |
      MessagePredicate Predicate |
      MessageOneLineTree OneLineTree |
      MessageCompose MessageBlocks
     deriving (Eq, Show, Read, Typeable)
   
   
-- TypeErrorHint is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/HeliumNT/Src/Staticanalysis/Messages/TypeErrors.hs:27
type TypeErrorHint = (String, MessageBlock)
 
-- Helium1v2.Src.HeliumNT.Src.Syntax.UHA_Syntax.Position
-- Position defined in HeliumBasicTypes
-- shared type
{-   deriving (Eq, Show, Read, Typeable)
-- Helium1v2.Src.HeliumNT.Src.Syntax.UHA_Syntax.Position is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/HeliumNT/Src/Syntax/UHA_Syntax.hs:153   deriving (Eq, Show, Read, Typeable)
data Helium1v2.Src.HeliumNT.Src.Syntax.UHA_Syntax.Position
    = Helium1v2.Src.HeliumNT.Src.Syntax.UHA_Syntax.Position_Position String Int Int |
      Helium1v2.Src.HeliumNT.Src.Syntax.UHA_Syntax.Position_Unknown
-}

-- MessageBlocks is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/HeliumNT/Src/Staticanalysis/Messages/Messages.hs:32
type MessageBlocks = [MessageBlock]

-- TpScheme is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/Top/Src/Top/Types/Schemes.hs:30
type TpScheme = Quantification Universal QType

-- Universal is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/Top/Src/Top/Types/Quantification.hs:66
data Universal = Universal -- added:" = Universal"; original "   data Universal", Data types with no constructors, -fglasgow-exts feature/ghc type-extension, http://www.haskell.org/ghc/docs/latest/html/users_guide/type-extensions.html#id3142855
     deriving (Eq, Show, Read, Typeable)

-- QType is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/Top/Src/Top/Types/Schemes.hs:31
type QType = Qualification Predicate Tp

-- Predicate is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/Top/Src/Top/Types/Classes.hs:25
data Predicate = Predicate String Tp
     deriving (Eq, Show, Read, Typeable)

-- Tp is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/Top/Src/Top/Types/Basics.hs:23
data Tp = TVar Int | TCon String | TApp Tp Tp
     deriving (Eq, Show, Read, Typeable)

-- OneLineTree is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/HeliumNT/Src/Utils/OneLiner.hs:13
data OneLineTree = OneLineNode [OneLineTree] | OneLineText String
     deriving (Eq, Show, Read, Typeable)

-- Qualification is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/Top/Src/Top/Types/Qualification.hs:20
newtype Qualification q a = Qualification ([q], a)
     deriving (Eq, Show, Read, Typeable)

-- Quantification is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/Top/Src/Top/Types/Quantification.hs:22
newtype Quantification q a = Quantification ([Int], QuantorMap, a)
     deriving (Eq, Show, Read, Typeable)

-- QuantorMap is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v2/Src/Top/Src/Top/Types/Quantification.hs:24
type QuantorMap = [(Int, String)]

{- Hel 1.2.X
:i TypeError
:i Range
:i MessageLine
:i MessageBlock
:i TypeErrorHint
--:i Position
:i Helium1v2.Src.HeliumNT.Src.Syntax.UHA_Syntax.Position
:i MessageBlocks
:i TpScheme
:i Universal
:i QType
:i Predicate
:i Tp
:i OneLineTree

-- added to make everything fit
:i Qualification
:i Quantification
:i QuantorMap


-}