module Thesis.HeliumUniversal.TypeError.Helium1v5TypeError where

import Thesis.HeliumUniversal.BasicTypes
import Data.Typeable

-- TypeError is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/HeliumNT/Src/Staticanalysis/Messages/TypeErrors.hs:23
data TypeError
    = TypeError [Range] [MessageLine] [(Bool, MessageBlock, MessageBlock)] [TypeErrorHint]
     deriving (Eq, Show, Read, Typeable)

-- placed in HeliumBasicTypes, shared datatype :i Range

-- MessageLine is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/HeliumNT/Src/Staticanalysis/Messages/Messages.hs:28
data MessageLine
    = MessageOneLiner MessageBlock |
      MessageTable [(Bool, MessageBlock, MessageBlock)] |
      MessageHints String MessageBlocks
     deriving (Eq, Show, Read, Typeable)

-- MessageBlock is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/HeliumNT/Src/Staticanalysis/Messages/Messages.hs:33
data MessageBlock
    = MessageString String |
      MessageRange Range |
      MessageType TpScheme |
      MessagePredicate Predicate |
      MessageOneLineTree OneLineTree |
      MessageCompose MessageBlocks
     deriving (Eq, Show, Read, Typeable)

-- TypeErrorHint is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/HeliumNT/Src/Staticanalysis/Messages/TypeErrors.hs:29
type TypeErrorHint = (String, MessageBlock)
     

-- placed in HeliumBasicTypes, shared datatype :i Helium1v5.Src.HeliumNT.Src.Syntax.UHA_Syntax.Position

-- MessageBlocks is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/HeliumNT/Src/Staticanalysis/Messages/Messages.hs:32
type MessageBlocks = [MessageBlock]

-- TpScheme is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/Top/Src/Top/Types/Schemes.hs:31
type TpScheme = Quantification Universal QType

-- Universal is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/Top/Src/Top/Types/Quantification.hs:76
data Universal = Universal -- added:" = Universal"; original "   data Universal", Data types with no constructors, -fglasgow-exts feature/ghc type-extension, http://www.haskell.org/ghc/docs/latest/html/users_guide/type-extensions.html#id3142855
     deriving (Eq, Show, Read, Typeable)

-- QType is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/Top/Src/Top/Types/Schemes.hs:32
type QType = Qualification Predicates Tp

-- Predicate is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/Top/Src/Top/Types/Classes.hs:26
data Predicate = Predicate String Tp
   deriving (Eq, Show, Read, Typeable)
   
-- Tp is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/Top/Src/Top/Types/Basics.hs:23
data Tp = TVar Int | TCon String | TApp Tp Tp
   deriving (Eq, Show, Read, Typeable)
   
-- OneLineTree is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/HeliumNT/Src/Utils/OneLiner.hs:13
data OneLineTree = OneLineNode [OneLineTree] | OneLineText String
   deriving (Eq, Show, Read, Typeable)
   
-- Predicates is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/Top/Src/Top/Types/Classes.hs:25
type Predicates = [Predicate]

-- Qualification is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/Top/Src/Top/Types/Qualification.hs:20
newtype Qualification q a = Qualification (q, a)
   deriving (Eq, Show, Read, Typeable)
-- Quantification is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/Top/Src/Top/Types/Quantification.hs:22
newtype Quantification q a = Quantification ([Int], QuantorMap, a)
   deriving (Eq, Show, Read, Typeable)
-- QuantorMap is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5/Src/Top/Src/Top/Types/Quantification.hs:24
type QuantorMap = [(Int, String)]


{- Hel 1.5.XStatic
:i TypeError
-- placed in HeliumBasicTypes, shared datatype :i Range
:i MessageLine
:i MessageBlock
:i TypeErrorHint
--:i Position
-- placed in HeliumBasicTypes, shared datatype :i Helium1v5.Src.HeliumNT.Src.Syntax.UHA_Syntax.Position
:i MessageBlocks
:i TpScheme
:i Universal
:i QType
:i Predicate
:i Tp
:i OneLineTree
:i Predicates
:i Qualification
:i Quantification
:i QuantorMap

-}

