module Thesis.Research.DataSetActivityResearch where
-- Standalone example for helium logging analysis

import Statistics.DescriptiveAnalysis
import Statistics.SummaryMeasures
import Statistics.Presentation

import Thesis.Metrics
import Thesis.Research.Common
import Thesis.Helium.Logging
import Data.Typeable

import Auxilary

-- import Thesis.Research.ProgramCharacteristics

default_logfile    = "datasets/demo/demo.log"
default_outputpath = "analysis_results/demo"

main = runNewResearchFromLogFile dataSetResearch startkey dflt_logfile dflt_outputpath HtmlFormat

dataSetResearch :: OutputFormat -> [(KeyHistory, [Logging])] -> FilePath -> IO ()
dataSetResearch format input outputpath = do
   do
      let
         -- runAna = runAnalysisGeneric logs key
         ana = nameDataSet "FP 0203"
         name = "Activity Research" -- (concat $ ppKeyGeneral $ head $ peekKey anametric) ++ " Research"
         researchdir = joinDirAndFileName outputpath (stringToFilePath name) ++ [pathSeparator]
         outputfile = joinDirFileExt researchdir (stringToFilePath name) $ showFormatExt format

         countAna :: AnalysisFK KeyHistory [Logging] Int
         countAna = basicAnalysis' "logging frequency" length

         loggingsPerStudentPerWeek = countAna <.> groupPerStudent <.> groupPerWeekFromSeq <.> ana

      createDirectoryIfMissing True researchdir

--      barPlotAvgNoOfMinPerGroupTtoC <-
  --       renderBarPlot1D (showCustomMaybe) researchdir $ avgNoOfMinFromTtoC <.> timeFromTtoC <.> grpsFromTtoCAfterSession
         -- show result data in tables
      writeFile outputfile
                  $ renderMarkUpDoc format $ document noHtml $
                     (section Nothing << name)
                     +++
                     (showAsMarkUpTable1D $ selectGrpAnalysis ((>10)) <.> loggingsPerStudentPerWeek <$> input)

      return ()

