module Thesis.Research.DataSetResearch where
-- Standalone example for helium logging analysis

import Statistics.DescriptiveAnalysis
import Statistics.Presentation
import Thesis.Research.Common
import Thesis.Helium.Logging


-- import Thesis.Research.ProgramCharacteristics

default_logfile    = "datasets/demo/demo.log"
default_outputpath = "analysis_results/demo"

testRunResearch :: (Keyable key) => ([Logging] -> key -> FilePath -> IO ()) -> IO ()
testRunResearch research = runResearchFromLogFileKeyable research default_logfile default_outputpath

main = testRunResearch dataSetResearch

dataSetResearch logs key outputpath =
   do
      let
         runAna = runAnalysisGeneric logs key
         ana = nameDataSet "FP 0203"
         countAna :: AnalysisFixedKey KeyHistory [Logging] Int
         countAna = basicAnalysis' "logging frequency" length

         countPhaseFreq :: AnalysisFixedKey KeyHistory [Logging] (Phase, Int)
         countPhaseFreq = undefined

         loggingsPerStudent = countAna <.> groupPerStudent <.> ana
      
      -- putStrLn $ show $ runAna ana
      -- putStrLn $ showAsTextSetList $ runAna ana
      -- putStrLn $ showAsCSVFile $ runAna ana
      -- putStrLn $ showListAsCSV [CSVShow ppLogging] $ runAna ana
      -- putStrLn $ showAsTextTable $ runAna (countAna <.> ana)
      
      putStrLn $ show $ runAna (countAna <.> ana)
      
      putStrLn $ renderHtml $ showAsMarkUpTable1D $ runAna (countAna <.> ana)

      putStrLn $ show $ runAna loggingsPerStudent
      putStrLn $ renderHtml $ showAsMarkUpTable1D $ runAna (countAna <.> groupPerStudent <.> ana)

      putStrLn $ show $ runAna loggingsPerStudent
      putStrLn $ renderHtml $ showAsMarkUpTable1D $ runAna (countAna <.> groupPerPhaseAna <.> groupPerStudent <.> ana)
