module Thesis.Research.TypingTillCodeResearchWOWH where

-- next to should be combined, in single default AC import
import Statistics.DescriptiveAnalysis
import Statistics.SummaryMeasures
import Statistics.Presentation

import Thesis.Metrics
import Thesis.Research.Common
import Thesis.Helium.Logging
import Thesis.Grouping.Logging (sameSourceFile)

import Grouping
import Data.Typeable

import Auxilary

import Data.Maybe
import Data.List
import System.Time

import Text.Regex

import Thesis.Research.TypingTillCodeResearch hiding (default_logfile, default_outputpath)
import Thesis.Research.HintCodeResearch hiding (default_logfile, default_outputpath)


{-

Wat mij betreft pas je 1 en 2 alleen toe op 04/05, misschien ter  
controle (wat betreft de uitkomsten) ook op 03/04.
1 Bereken per student, per week, de (gemiddelde tijd, gemiddelde  
aantal compiles) per sessie, benodigd om van een T
    compilatie te komen tot een C compilatie.
    [ C P T T T P T C L  L P P T C ] wordt [T T T P T C], [ T C ]

Session = is op tijd en filenaam
generated for student 29, 71 and 86 from the fp0203 data set

effect met of zonder hint
-}

default_logfile    = "datasets/demo/demo.log"
default_outputpath = "analysis_results/demo"

main = runNewResearchFromLogFile typingTillCodeResearchWOWH startkey default_logfile default_outputpath HtmlFormat -- LateXFormatInclude

typingTillCodeResearchWOWH :: OutputFormat -> [(KeyHistory, [Logging])] -> FilePath -> IO ()
typingTillCodeResearchWOWH format input outputpath = do
   let
      -- ana = runAnalysisGeneric logs key $ groupPerWeek
      name = "1B. Typing Research (with of without type hint)" -- (concat $ ppKeyGeneral $ head $ peekKey anametric) ++ " Research"
      researchdir = joinDirAndFileName outputpath (stringToFilePath name) ++ [pathSeparator]
      outputfile = joinDirFileExt researchdir (stringToFilePath name) $ showFormatExt format

   createDirectoryIfMissing True researchdir
 
   -- show result data in tables
   writeFile outputfile
      $ renderMarkUpDoc format $ document noHtml $
         (section Nothing << name)
         +++
         plotToFigure boxPlotNoLogsPerSessionTtoC
         +++
         plotToFigure boxPlotNoSecPerSessionTtoC
         +++
         (barPlotAvgNoLogsPerGroupTtoC)
         +++
         (barPlotAvgNoOfMinPerGroupTtoC)
         +++
         (showAsMarkUpTable1D $ averageTtoCLength <.> grpsNoOfLogsFromTtoC <$> input)
         +++
         (showAsMarkUpTable1D $ avgNoOfSecFromTtoC <.> timeFromTtoC <.> grpsAvgNoOfMinFromTtoC <$> input)
         +++
         (showAsMarkUpTable1D $ avgNoOfMinFromTtoC <.> timeFromTtoC <.> grpsAvgNoOfMinFromTtoC <$> input)
--                     +++
--                     (showAsMarkUpTable1D $ groupOverview <.> grpsFromTtoC <$> input)
         +++
         (showAsMarkUpTable1D $ groupOverview <.> grpsNoOfLogsFromTtoC <$> input)
         +++
         (showAsMarkUpTable1D $ groupOverview <.> grpsAvgNoOfMinFromTtoC <$> input)

   return ()

