module Thesis.Settings 
   ( programdir
   , heliumcompilerslocation
   , tmpdir
   , workingdir
   , datasetdir
   , logfile
   , datasetdirFP0203
   , datasetdirFP0304
   {-
   , heliums
   , helium1v0
   , helium1v1   
   , helium1v1A  
   , helium1v1v1 
   , helium1v1v2 
   , helium1v2   
   , helium1v2v1 
   , helium1v2v2 
   , helium1v5
   , helium1v5v1
   -}
   , outExt
   , outExtVerbose
   , outExtInstrumented
   , CollegePeriod (..)
   , PeriodName (..)
   , fpCourses
   , dirsep
   ) where

-- import Thesis.Helium.Logging
import Auxilary

--------------------------------------------------------------------------
-- Program Settings
--------------------------------------------------------------------------

-- Location of Analysis Program (unchangable)
programdir = "/users/pkeeken/trunk/development/heliumprganalysis/trunk/bin/"

-- Location of different (instrumented) helium compilers (fixed)
heliumcompilerslocation = "/users/pkeeken/trunk/development/instrumented_helium_compilers/"
--"/users/pkeeken/local/apps/" -- helium-<version>-[<builddate>] / src

-- Temp dir, avoid use of it
tmpdir = "/scratch/tmp/"
   -- "/users/pkeeken/trunk/development/heliumprganalysis/trunk/tmp/"
-- tmpdir = "D:\\thesiswork\\data\\tmpdir\\"

dirsep = "/"  -- see also how slash is handled in Hint source

-- std sub dirs, required for proper use -- mind 1.5 incompatibility
heliumbindir = "bin"
heliumsrclib = "lib"
heliumsrcdir = "src"

-- Location of datasets (user setting)
workingdir = "/scratch/data/fp/archives/"
datasetdir = workingdir ++  "fp-0304-p3" ++ "/" --  "fp-0405-p3" ++ "/" -- "helium0203" ++ "/"
logfile = "fp0304_recompilation_onlyCompiles_fst2000.log"  -- "fp0405_original.log" -- "fp0203_recompilation_onlyCompiles.log"  -- "fp0304_recompilation_onlyCompiles.log"

datasetdirFP0203 = workingdir ++ "helium0203" ++ "/"
logfileFP0203 = "fp0203_recompilation_onlyCompiles1000.log"

datasetdirFP0304 = workingdir ++ "fp-0304-p3" ++ "/" 
logfileFP0304 = "fp0304_original.log"

-- extentions to the helium logging compilation output file
outExt :: String
outExt = ".out-"

outExtVerbose :: String
outExtVerbose = ".outverbose-"

outExtInstrumented :: String
outExtInstrumented = ".outInstrumented-"

--
-- FP Course information
--

-- Data type for analysis about periods, here?
data CollegePeriod = CollegePeriod {
                 periodName :: PeriodName,
                 periodStart :: CalendarDate,
                 periodEnd :: CalendarDate 
              }
   deriving (Show, Read, Eq, Ord)

data PeriodName = Fp0203 | Fp0304 | Fp0405
   deriving (Show, Read, Eq, Ord)

fp0203 = CollegePeriod
            Fp0203
            "2002-09-01@00_00_00_000" -- (fromGregorian 2002 09 01)
            "2003-07-10@00_00_00_000" -- (fromGregorian 2003 07 10)

fp0304 = CollegePeriod
            Fp0304
            "2003-09-01@00_00_00_000" -- (fromGregorian 2003 09 01)
            "2004-07-10@00_00_00_000" -- (fromGregorian 2004 07 10)

fp0405 = CollegePeriod
            Fp0405
            "2004-09-01@00_00_00_000" -- (fromGregorian 2004 09 01)
            "2005-07-10@00_00_00_000" -- (fromGregorian 2005 07 10)

fpCourses = [ fp0203, fp0304, fp0405 ]

