// Specify some data (or it could be read from a file).
// Proc rangebar will compute medians and percentiles.
// Non-conformant data will be ignored.
#proc getdata
data:   
2 	3 	2.7 	1.0	1.5
2.1	3.1	2.8	1.2	2.1
2.2	3.3	3.2	3.2	2.3
1.3	3.4	1.5	1.2	4.8
2 	3 	2.7 	1.0	1.5
3.6	3.3	3.2	2.9	2.8
2.1	3.1	2.8	1.2	2.1
3.5	4.4	1.6	NA	4.0
2.4	3.8	2.7	NA	3.2
NA	0.7	2.9	2.1	3.1
NA	4.8	2.5	2.7	0.7


#proc categories
  axis: x
  categories:
    red
    blue
    orange  
    purp
    green

// set up the area and scaling..
#proc areadef
  rectangle: 1 1 5 2
  xrange: 0 6
  yrange: 0 5
   // axes: none
//  xscaletype: categories
  // xaxis.stubs: usecategories

#proc xaxis
  axisline: none
  stubs: text
	New York
	Atlanta
	Detroit
	Baltimore

// do a Y axis (grid only).. 
#proc yaxis
  grid: color=green
  stubs: inc
//  tics: none
//  axisline: none


// do the 1st boxplot.. 
#proc rangebar
  datafield: 1
  barloc: 1
  nlocation: 0.1(s)
  showstats: yes
  color: pink
  mediansym: radius=0
  meansym: shape=circle style=fill fillcolor=blue radius=0.04
//  mediansym: shape=circle style=fill fillcolor=blue radius=0.04
  #saveas B

// do the 2nd boxplot, cloning the 1st.. 
#proc rangebar
  #clone B
  datafield: 2
  barloc: 2

// and so on.. 
#proc rangebar
  #clone B
  datafield: 3
  barloc: 3

#proc rangebar
  #clone B
  datafield: 4
  barloc: 4

#proc rangebar
  #clone B
  datafield: 5
  barloc: 5
