// ploticus data display engine.  Software, documentation, and examples.  
// Copyright 1998-2002 Stephen C. Grubb  (scg@jax.org).
// Covered by GPL; see the file 'Copyright' for details. 
// http://ploticus.sourceforge.net

//// extention by pa

//// STACK - do a stacked bar graph 


//// load stack-specific parms..
#setifnotgiven xnumeric = ""
#setifnotgiven y2 = ""
#setifnotgiven y3 = ""
#setifnotgiven y4 = ""
#setifnotgiven y5 = ""
#setifnotgiven y6 = ""
#setifnotgiven y7 = ""
#setifnotgiven y8 = ""
#setifnotgiven y9 = ""
#setifnotgiven y10 = ""
#setifnotgiven color = orange
#setifnotgiven color2 = "powderblue"
#setifnotgiven color3 = "dullyellow"
#setifnotgiven color4 = "kelleygreen"
#setifnotgiven color5 = "oceanblue"
#setifnotgiven color6 = "lavender"
#setifnotgiven color7 = "limegreen"
#setifnotgiven color8 = "tan2"
#setifnotgiven color9 = "claret"
#setifnotgiven color10 = "drabgreen"
#setifnotgiven name = "#usefname"
#setifnotgiven name2 = "#usefname"
#setifnotgiven name3 = "#usefname"
#setifnotgiven name4 = "#usefname"
#setifnotgiven name5 = "#usefname"
#setifnotgiven name6 = "#usefname"
#setifnotgiven name7 = "#usefname"
#setifnotgiven name8 = "#usefname"
#setifnotgiven name9 = "#usefname"
#setifnotgiven name10= "#usefname"
#setifnotgiven outline = no
#setifnotgiven reverseleg = no
#setifnotgiven stackarea = no
#if @CM_UNITS = 1
  #setifnotgiven legend = "min+1.25 max+1.25"
#else
  #setifnotgiven legend = "min+0.5 max+0.5"
#endif


//// load standard parms..
#include $chunk_setstd


//// read data..
#set context = stack
//// + pvk added extended version to chunk_read
#include $chunk_read_ext


//// plot area..
#include $chunk_area
#if @xnumeric = yes
  #set incmult = 2.0
  #if @stackarea = yes
    #set incmult = 1.0
  #endif
  #write stderr
    incmult = @incmult
  #endwrite
  xautorange: datafield=@x incmult=@incmult nearest=@xnearest
#else
  xscaletype: categories
  xcategories: datafield=@x
  // following added 9/2/02 scg
  catcompmethod: exact
#endif

#if @stackarea = yes
  #set combomode = normal
#else
  #set combomode = stack
#endif
#if @yrange = ""
  yautorange: datafields=@y,@y2,@y3,@y4,@y5,@y6,@y7,@y8,@y9,@y10 combomode=@combomode incmult=2.0  nearest=@ynearest
//#elseif @yrange = 0
#elseif $ntoken( 2, @yrange ) = ""
  yautorange: datafields=@y,@y2,@y3,@y4,@y5,@y6,@y7,@y8,@y9,@y10 combomode=@combomode incmult=2.0 mininit=@yrange nearest=@ynearest
#else
  yrange: @yrange
#endif


//// x axis..
#include $chunk_xaxis
stubcull: yes
#if @xnumeric = yes
  stubs: inc @xinc
#else
  stubs: usecategories
#endif


//// y axis..
#include $chunk_yaxis
stubcull: yes


//// title..
#include $chunk_title


//// user pre-plot include..
#if @include1 != ""
  #include @include1
#endif

#if @stackarea = yes
  #if @name = "#usefname"
    #set name = "Tier 1"
    #set name2 = "Tier 2"
    #set name3 = "Tier 3"
    #set name4 = "Tier 4"
    #set name5 = "Tier 5"
    #set name6 = "Tier 6"
    #set name7 = "Tier 7"
    #set name8 = "Tier 8"
    #set name9 = "Tier 9"
    #set name10 = "Tier 10"
    #write stderr
       Warning: With stackarea, legend labels must be specified (name= .. name2=..)
    #endwrite
  #endif
  #if @y10 != ""
    #proc lineplot 
     xfield: @x
     yfield: @y10
     fill: @color10
     legendlabel: @name10
  #endif
  #if @y9 != ""
    #proc lineplot 
     xfield: @x
     yfield: @y9
     fill: @color9
     legendlabel: @name9
  #endif
  #if @y8 != ""
    #proc lineplot 
     xfield: @x
     yfield: @y8
     fill: @color8
     legendlabel: @name8
  #endif
  #if @y7 != ""
    #proc lineplot 
     xfield: @x
     yfield: @y7
     fill: @color7
     legendlabel: @name7
  #endif
  #if @y6 != ""
    #proc lineplot 
     xfield: @x
     yfield: @y6
     fill: @color6
     legendlabel: @name6
  #endif
  #if @y5 != ""
    #proc lineplot 
     xfield: @x
     yfield: @y5
     fill: @color5
     legendlabel: @name5
  #endif
  #if @y4 != ""
    #proc lineplot 
     xfield: @x
     yfield: @y4
     fill: @color4
     legendlabel: @name4
  #endif
  #if @y3 != ""
    #proc lineplot 
     xfield: @x
     yfield: @y3
     fill: @color3
     legendlabel: @name3
  #endif
  #if @y2 != ""
    #proc lineplot 
     xfield: @x
     yfield: @y2
     fill: @color2
     legendlabel: @name2
  #endif
  #proc lineplot
  xfield: @x
  yfield: @y
  fill: @color
  legendlabel: @name

#else
  
  //// do 1st level bars..
  #proc bars
  locfield: @x
  lenfield: @y
  color: @color
  outline: @outline
  #ifspec barwidth
  legendlabel: @name
  #ifspec ptselect select
  
  //// 2nd level bars..
  #if @y2 != ""
    #proc bars
    locfield: @x
    lenfield: @y2
    stackfields: *
    color: @color2
    outline: @outline
    #ifspec barwidth
    legendlabel: @name2
    #ifspec ptselect2 select
  #endif
  
  //// 3rd level bars..
  #if @y3 != ""
    #proc bars
    locfield: @x
    lenfield: @y3
    stackfields: *
    color: @color3
    outline: @outline
    #ifspec barwidth
    legendlabel: @name3
    #ifspec ptselect3 select
  #endif
  
  //// 4th level bars..
  #if @y4 != ""
    #proc bars
    locfield: @x
    lenfield: @y4
    stackfields: *
    color: @color4
    outline: @outline
    #ifspec barwidth
    legendlabel: @name4
    #ifspec ptselect4 select
  #endif
  
  //// 5nd level bars..
  #if @y5 != ""
    #proc bars
    locfield: @x
    lenfield: @y5
    stackfields: *
    color: @color5
    outline: @outline
    #ifspec barwidth
    legendlabel: @name5
    #ifspec ptselect5 select
  #endif
  
  //// 6rd level bars..
  #if @y6 != ""
    #proc bars
    locfield: @x
    lenfield: @y6
    stackfields: *
    color: @color6
    outline: @outline
    #ifspec barwidth
    legendlabel: @name6
    #ifspec ptselect6 select
  #endif
  
  //// 7th level bars..
  #if @y7 != ""
    #proc bars
    locfield: @x
    lenfield: @y7
    stackfields: *
    color: @color7
    outline: @outline
    #ifspec barwidth
    legendlabel: @name7
    #ifspec ptselect7 select
  #endif
  
  //// 8nd level bars..
  #if @y8 != ""
    #proc bars
    locfield: @x
    lenfield: @y8
    stackfields: *
    color: @color8
    outline: @outline
    #ifspec barwidth
    legendlabel: @name8
    #ifspec ptselect8 select
  #endif
  
  //// 9rd level bars..
  #if @y9 != ""
    #proc bars
    locfield: @x
    lenfield: @y9
    stackfields: *
    color: @color9
    outline: @outline
    #ifspec barwidth
    legendlabel: @name9
    #ifspec ptselect9 select
  #endif
  
  //// 10th level bars..
  #if @y10 != ""
    #proc bars
    locfield: @x
    lenfield: @y10
    stackfields: *
    color: @color10
    outline: @outline
    #ifspec barwidth
    legendlabel: @name10
    #ifspec ptselect10 select
  #endif

#endif
  
//// legend..
#if @name != "#usefname" || @header = yes
  #proc legend
  location: @legend
  reverseorder: @reverseleg
  #ifspec legendfmt format
  #ifspec legendsep sep
  #ifspec legwrap wraplen
  #ifspec legbreak extent
  #ifspec legtitle title
  #ifspec legbox backcolor
  #ifspec legframe frame
  #ifspec legtextdet textdetails

#endif

//// user post-plot include..
#if @include2 != ""
  #include @include2
#endif
